----
-- Config
----
showChatMsg = 1;
showFloatingMsg = 0;

----
-- OnLoad handler
----
function XToLevel_OnLoad()
	this:RegisterEvent("ADDON_LOADED");
	this:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
	
	SLASH_XTOLEVEL1 = "/xtolevel";
	SLASH_XTOLEVEL2 = "/xtl";
	SlashCmdList["XTOLEVEL"] = CLI_Command;
end

----
-- OnEvent handler
----
function XToLevel_OnEvent()
	if (event=="CHAT_MSG_COMBAT_XP_GAIN") then
		-- Check if no message should be sent
		if (showChatMsg == 1 and showFloatingMsg == 1) then
			return
		end
	
		local msg = "n/a"
			
		-- Gather the XP data
		local playerXP = UnitXP("player")
		local playerXPMax = UnitXPMax("player")
		local playerXPRested = GetXPExhaustion() or 0
		
		-- Check if the rested bonus extends beiond the next level
		if(playerXP + playerXPRested > playerXPMax) then
			playerXPRested = (playerXPMax - playerXP)
		end
		
		-- Extract the XP from the message
		local gStart, gEnd = string.find(arg1, "gain")
		local eStart, eEnd = string.find(arg1, "experience")
		local xpGained = tonumber(strsub(arg1, gEnd + 2, eStart - 2))
	
		-- Check if it was a mob kill or a quest hand in
		if(playerXP + xpGained > playerXPMax) then
			msg = "Level reached. Congratulations"
		elseif(nil == string.find(arg1, "dies")) then
			-- Calculate the ammount of quest turnins to level
			--  (TotalLevelXP - XPSoFar - GainedXP) / GainedXP
			local questsToLevel = ceil((playerXPMax - playerXP - xpGained) / xpGained)
			
			-- Create message
			msg = questsToLevel .. " more quests like that needed to level"
		else
			-- Load mob name
			local dStart, dEnd = string.find(arg1, "dies")
			local mobName = strsub(arg1, 0, dStart - 2)
			
			-- Check if the XP gained was rested
			if(playerXPRested > 0) then
				if(playerXPRested * 2 < xpGained) then
					xpGained = xpGained - playerXPRested
				else
					xpGained = xpGained / 2
				end
			end
			
			-- Calculate the ammount of mobs needed
			--  (TotalLevelXP - XPSoFar - (RestedBonus)) / GainedXP
			local mobsNeededToLevel = ceil((playerXPMax - playerXP - (playerXPRested / 2) - xpGained) / xpGained)
			
			-- Create Message
			msg = mobsNeededToLevel .." ".. mobName .." needed to level"
		end
			
		-- Send Message
		if(showChatMsg == 0) then
			DEFAULT_CHAT_FRAME:AddMessage(msg, 0, 100, 200, 55, 4);
		end
		if(showFloatingMsg == 0) then
			UIErrorsFrame:AddMessage(msg, 0, 100, 200, 55, 4);
		end
		
	elseif(event=="ADDON_LOADED" and arg1=="MobsToLevel") then
		DEFAULT_CHAT_FRAME:AddMessage("XToLevel version 1.0 Loaded.");
	end
end

----
-- CLI command handler
----
function CLI_Command(cmd)
	local msg = nil

	-- Toogle Chat
	if (cmd == "toogle chat") then
		if (showChatMsg == 0) then
			showChatMsg = 1
			msg = "XToLevel: Chat messages disabled"
		else
			showChatMsg = 0
			msg = "XToLevel: Chat messages enabled"
		end
		DEFAULT_CHAT_FRAME:AddMessage(msg)
		
	-- Toogle Floating
	elseif(cmd == "toogle floating") then
		if (showFloatingMsg == 0) then
			showFloatingMsg = 1
			msg = "XToLevel: Floating messages disabled"
		else
			showFloatingMsg = 0
			msg = "XToLevel: Floating messages enabled"
		end
		DEFAULT_CHAT_FRAME:AddMessage(msg)
		
	-- Show info
	elseif(cmd == "status") then
		-- Print info
		DEFAULT_CHAT_FRAME:AddMessage("XToLevel status:")
		if (showChatMsg == 0) then
			DEFAULT_CHAT_FRAME:AddMessage(" - Chat messages enabled")
		else
			DEFAULT_CHAT_FRAME:AddMessage(" - Chat messages disabled")
		end
		if (showFloatingMsg == 0) then
			DEFAULT_CHAT_FRAME:AddMessage(" - Floating messages enabled")
		else
			DEFAULT_CHAT_FRAME:AddMessage(" - Floating messages disabled")
		end
	
	-- Show error and valid commands
	else
		DEFAULT_CHAT_FRAME:AddMessage("Invalid command")
		DEFAULT_CHAT_FRAME:AddMessage("Valid commands: ")
		DEFAULT_CHAT_FRAME:AddMessage("  toogle chat -- toogles the chat notice")
		DEFAULT_CHAT_FRAME:AddMessage("  toogle floating -- toogles the floating notice")
		DEFAULT_CHAT_FRAME:AddMessage("  status -- display current config")
	end
end